#include <boost/unordered_set.hpp> 
#include <string> 
#include <iostream>

struct person 
{ 
	std::string name; 
	int age; 

	person(const std::string &n, int a) : name(n), age(a) {} 

	bool operator==(const person &p) const 
	{ 
		return name == p.name && age == p.age; 
	} 
}; 

std::size_t hash_value(person const &p) 
{ 
	std::size_t seed = 0; 
	boost::hash_combine(seed, p.name); 
	boost::hash_combine(seed, p.age); 
	return seed; 
} 

int main() 
{ 
	typedef boost::unordered_set<person> unordered_set; 
	unordered_set set; 

	set.insert(person("Alex", 11)); 
	set.insert(person("Bob", 32)); 
	set.insert(person("Alice", 20));
	for (unordered_set::iterator it = set.begin(); it != set.end(); ++it) 
		std::cout << it->name <<' ' << it->age << std::endl;
//	std::cout << set.hash_function()(person("Alex", 12));
} 
