#include <boost/unordered_set.hpp>
#include <iostream>

#define ELEMENT_NUM 50
struct ihash : std::unary_function<int, std::size_t>
{
    std::size_t operator()(int const& x) const
    {
        return x;
    }
};

typedef boost::unordered_multiset<int, ihash> unordered_set;
unordered_set set;
	

void print()
{
	std::cout<<std::endl;	
	//количество элементов в каждом разделе	
	for (int i = 0; i < set.bucket_count(); ++i)
		if (set.bucket_size(i) > 1)
			std::cout<< "Bucket "<<i<<": "<<set.bucket_size(i)<<std::endl;
	
	std::cout<<std::endl;
	//в каком разделе какой элемент
	for (int i = 0; i < ELEMENT_NUM; ++i)
		std::cout<<i<<" in bucket "<<set.bucket(i)<<std::endl;
}

int main()
{
	//set.rehash(23);
	std::cout<<"Max bucket count: "<<set.max_bucket_count()<<std::endl;
	int bc = set.bucket_count();
	std::cout<<"Bucket count: "<<bc<<std::endl;
	for (int i = 0; i < ELEMENT_NUM; ++i)
	{
		set.insert(i);
		if (bc < set.bucket_count())
		{
			std::cout<<"Bucket count: "<<set.bucket_count()<<std::endl;
			bc = set.bucket_count();
		}
	}	
	
	print();
	std::cout<<"Load_factor: "<<set.load_factor()<<std::endl;
	std::cout<<"Max_load_factor: "<<set.max_load_factor()<<std::endl;
	set.max_load_factor(3);
	std::cout<<"Max_load_factor: "<<set.max_load_factor()<<std::endl;
	set.rehash(11);
	std::cout<<"Load_factor: "<<set.load_factor()<<std::endl;
	std::cout<<"Bucket count: "<<set.bucket_count()<<std::endl;
	print();
	return 0;
}
